[openssh-commits] [openssh] 05/05: upstream commit

git+noreply at mindrot.org git+noreply at mindrot.org
Sun Mar 12 10:51:09 AEDT 2017


This is an automated email from the git hooks/post-receive script.

djm pushed a commit to branch master
in repository openssh.

commit 8ff3fc3f2f7c13e8968717bc2b895ee32c441275
Author: djm at openbsd.org <djm at openbsd.org>
Date:   Sat Mar 11 23:44:16 2017 +0000

    upstream commit
    
    regress tests for loading certificates without public keys;
    bz#2617 based on patch from Adam Eijdenberg; ok markus@ dtucker@
    
    Upstream-Regress-ID: 0145d19328ed995b73fe2d9da33596b17429d0d0
---
 regress/cert-file.sh | 53 +++++++++++++++++++++++++++++++++++++++++-----------
 1 file changed, 42 insertions(+), 11 deletions(-)

diff --git a/regress/cert-file.sh b/regress/cert-file.sh
index b184e7f..43b8e02 100644
--- a/regress/cert-file.sh
+++ b/regress/cert-file.sh
@@ -1,4 +1,4 @@
-#	$OpenBSD: cert-file.sh,v 1.4 2016/12/16 02:48:55 djm Exp $
+#	$OpenBSD: cert-file.sh,v 1.5 2017/03/11 23:44:16 djm Exp $
 #	Placed in the Public Domain.
 
 tid="ssh with certificates"
@@ -17,24 +17,59 @@ ${SSHKEYGEN} -q -N '' -t ed25519 -f $OBJ/user_key1 || \
 	fatal "ssh-keygen failed"
 ${SSHKEYGEN} -q -N '' -t ed25519 -f $OBJ/user_key2 || \
 	fatal "ssh-keygen failed"
+${SSHKEYGEN} -q -N '' -t ed25519 -f $OBJ/user_key3 || \
+	fatal "ssh-keygen failed"
+${SSHKEYGEN} -q -N '' -t ed25519 -f $OBJ/user_key4 || \
+	fatal "ssh-keygen failed"
+${SSHKEYGEN} -q -N '' -t ed25519 -f $OBJ/user_key5 || \
+	fatal "ssh-keygen failed"
+
 # Move the certificate to a different address to better control
 # when it is offered.
 ${SSHKEYGEN} -q -s $OBJ/user_ca_key1 -I "regress user key for $USER" \
 	-z $$ -n ${USER} $OBJ/user_key1 ||
-		fail "couldn't sign user_key1 with user_ca_key1"
+		fatal "couldn't sign user_key1 with user_ca_key1"
 mv $OBJ/user_key1-cert.pub $OBJ/cert_user_key1_1.pub
 ${SSHKEYGEN} -q -s $OBJ/user_ca_key2 -I "regress user key for $USER" \
 	-z $$ -n ${USER} $OBJ/user_key1 ||
-		fail "couldn't sign user_key1 with user_ca_key2"
+		fatal "couldn't sign user_key1 with user_ca_key2"
 mv $OBJ/user_key1-cert.pub $OBJ/cert_user_key1_2.pub
+${SSHKEYGEN} -q -s $OBJ/user_ca_key1 -I "regress user key for $USER" \
+	-z $$ -n ${USER} $OBJ/user_key3 ||
+		fatal "couldn't sign user_key3 with user_ca_key1"
+rm $OBJ/user_key3.pub # to test use of private key w/o public half.
+${SSHKEYGEN} -q -s $OBJ/user_ca_key1 -I "regress user key for $USER" \
+	-z $$ -n ${USER} $OBJ/user_key4 ||
+		fatal "couldn't sign user_key4 with user_ca_key1"
+rm $OBJ/user_key4 $OBJ/user_key4.pub # to test no matching pub/private key case.
 
 trace 'try with identity files'
 opts="-F $OBJ/ssh_proxy -oIdentitiesOnly=yes"
 opts2="$opts -i $OBJ/user_key1 -i $OBJ/user_key2"
 echo "cert-authority $(cat $OBJ/user_ca_key1.pub)" > $OBJ/authorized_keys_$USER
 
+# Make a clean config that doesn't have any pre-added identities.
+cat $OBJ/ssh_proxy | grep -v IdentityFile > $OBJ/no_identity_config
+
+# XXX: verify that certificate used was what we expect. Needs exposure of
+# keys via enviornment variable or similar.
+
 for p in ${SSH_PROTOCOLS}; do
+	# Key with no .pub should work - finding the equivalent *-cert.pub.
+	verbose "protocol $p: identity cert with no plain public file"
+	${SSH} -F $OBJ/no_identity_config -oIdentitiesOnly=yes \
+	    -i $OBJ/user_key3 somehost exit 5$p
+	[ $? -ne 5$p ] && fail "ssh failed"
+
+	# CertificateFile matching private key with no .pub file should work.
+	verbose "protocol $p: CertificateFile with no plain public file"
+	${SSH} -F $OBJ/no_identity_config -oIdentitiesOnly=yes \
+	    -oCertificateFile=$OBJ/user_key3-cert.pub \
+	    -i $OBJ/user_key3 somehost exit 5$p
+	[ $? -ne 5$p ] && fail "ssh failed"
+
 	# Just keys should fail
+	verbose "protocol $p: plain keys"
 	${SSH} $opts2 somehost exit 5$p
 	r=$?
 	if [ $r -eq 5$p ]; then
@@ -42,6 +77,7 @@ for p in ${SSH_PROTOCOLS}; do
 	fi
 
 	# Keys with untrusted cert should fail.
+	verbose "protocol $p: untrusted cert"
 	opts3="$opts2 -oCertificateFile=$OBJ/cert_user_key1_2.pub"
 	${SSH} $opts3 somehost exit 5$p
 	r=$?
@@ -50,6 +86,7 @@ for p in ${SSH_PROTOCOLS}; do
 	fi
 
 	# Good cert with bad key should fail.
+	verbose "protocol $p: good cert, bad key"
 	opts3="$opts -i $OBJ/user_key2"
 	opts3="$opts3 -oCertificateFile=$OBJ/cert_user_key1_1.pub"
 	${SSH} $opts3 somehost exit 5$p
@@ -59,6 +96,7 @@ for p in ${SSH_PROTOCOLS}; do
 	fi
 
 	# Keys with one trusted cert, should succeed.
+	verbose "protocol $p: single trusted"
 	opts3="$opts2 -oCertificateFile=$OBJ/cert_user_key1_1.pub"
 	${SSH} $opts3 somehost exit 5$p
 	r=$?
@@ -67,6 +105,7 @@ for p in ${SSH_PROTOCOLS}; do
 	fi
 
 	# Multiple certs and keys, with one trusted cert, should succeed.
+	verbose "protocol $p: multiple trusted"
 	opts3="$opts2 -oCertificateFile=$OBJ/cert_user_key1_2.pub"
 	opts3="$opts3 -oCertificateFile=$OBJ/cert_user_key1_1.pub"
 	${SSH} $opts3 somehost exit 5$p
@@ -74,14 +113,6 @@ for p in ${SSH_PROTOCOLS}; do
 	if [ $r -ne 5$p ]; then
 		fail "ssh failed with multiple certs in protocol $p"
 	fi
-
-	#Keys with trusted certificate specified in config options, should succeed.
-	opts3="$opts2 -oCertificateFile=$OBJ/cert_user_key1_1.pub"
-	${SSH} $opts3 somehost exit 5$p
-	r=$?
-	if [ $r -ne 5$p ]; then
-		fail "ssh failed with trusted cert in config in protocol $p"
-	fi
 done
 
 #next, using an agent in combination with the keys

-- 
To stop receiving notification emails like this one, please contact
djm at mindrot.org.


More information about the openssh-commits mailing list